<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--       
*     Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved. 
*     Use is subject to license terms.
-->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>web.xml Visual Editor: Servlets</title>
<link rel="stylesheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
</head>
<body>
<h2><tt>web.xml</tt> Visual Editor: Servlets</h2>
<p> <small><a href="#seealso">See Also</a>&nbsp; </small> 
 
<p>Use the Servlet section of the <tt>web.xml</tt> Visual Editor to add, remove, and
 view the deployment information of your web application's servlets and, optionally,
 JSP files. </p>
 <h3>Servlets</h3>
 <p>Servlets are Java classes that can be loaded dynamically into a server 
 and executed by the server to extend its feature set. Servlets are useful 
 for tasks that involve processing an HTTP request. Servlets are also helpful 
 for tasks that do not generate an HTTP response at all or that generate a relatively 
 simple HTTP response. Servlets use the javax.servlet API.</p>
 <p>To deploy a servlet, you must register it in the <tt>web.xml</tt> file. 
 Doing this provides information needed by the server to deploy the servlet.
 For example, you tell the server which class should be loaded to deploy
 the servlet.</p>
 <h3>JSP Files</h3>
 <p>JSP technology was designed to simplify the process of creating servlets. 
 In fact, the main function of servlets is to generate HTML output in cases where 
 dynamic portions can be encapsulated. Servlets are generated by JSP pages when compiled.
 In many applications, the response sent to the client is a combination of template data 
 and dynamically-generated data. In this situation, it is often easier to work with JSP pages 
 than to do everything with servlets.</p>
 <p>Unlike servlets, the server automatically deploys JSP files, therefore
 you do not have to register a JSP files in
 the <tt>web.xml</tt> file in order to deploy it. However, if you register a JSP file
 in the <tt>web.xml</tt> file, you can use servlet elements to set initialization parameters 
 and mappings for the JSP file, just as if it were a servlet.</p>
<p>Before registering a servlet or JSP file in the <tt>web.xml</tt> file, you can
<a href="../../create/servlet/servlet_create.html">create the servlet</a>
or <a href="../../create/jsp/jsp_create.html">create the JSP file</a> in the New File wizard,
or  <a href="../../csh/projwiz_standard/ThePanel.html">import it</a> from your existing sources.
You can use the Configure Servlet Deployment panel of the New File wizard
to register a servlet. If you have not done so, or if you want to modify a registered servlet's
deployment information, use the Servlets view of the
<tt>web.xml</tt> Visual Editor. Note that you cannot use the New File wizard
to register JSP files.</p>

<p>You open the <tt>web.xml</tt> Visual Editor 
 from the Projects window by 
expanding the Web Pages node, then the WEB-INF node, and then double-clicking
the <tt>web.xml</tt> file. Click Servlets at the top of the editor
 to open the Servlets view.

<p>First, click Add Servlet Element to define the servlet element with the following properties:
</p><ul>
<li><b>Servlet Name. </b>Specifies the display name of the servlet or JSP file, such as <tt>MyVeryUsefulComponent</tt>.</li>
<li><b>Description. </b> Specifies a description, such as <tt>Initialization settings for my JSP file</tt>.</li>
<li>Now specify the servlet class or JSP file, by doing one of the following:
<ul>
<li><b>Servlet Class. </b>Specifies the servlet's class, such as <tt>MyVeryUsefulServlet</tt>.</li>
<li><b>JSP File. </b>Specifies the JSP file, such as <tt>MyVeryUseFulPage</tt>.</li>
</ul>

<li><b>URL Pattern(s). </b> Specifies a mapping between the 
 servlet definition or JSP file definition and a URL pattern, such as <tt>/bookstore/*, *.jsp</tt>.
 All requests to the specified URL patterns are handled by the servlet or JSP file associated with the 
 servlet or JSP file definition.</li>
</ul>
<p>When you click OK, the values you entered are displayed in the Servlets section. Optionally, you can now
specify the startup order of the servlets in the application. In the Startup Order edit box, type an
integer indicating the order in which the servlets should be loaded.</p>

<p><b>Initialization Parameters</b></p>
<p>Next, click Add within the servlet element and define its initialization parameters:</p>
<ul>
<li><b>Param Name. </b>Specifies the parameter's display name, such as <tt>encoding</tt>.</li>
<li><b>Param Value. </b>Specifies the parameter's value, such as <tt>UTF-8</tt>.</li>
<li><b>Description. </b> Specifies a description, such as <tt>Acceptable encoding formats</tt>.</li>
</ul>

<p><b>Security Role References</b></p>
<p>Optionally, click Add under Security Role References for the servlet to add role references:</p>
<ul>
<li><b>Role Ref Name.</b> Specifies the security role reference's display name.</li>
<li><b>Role Ref Link.</b> Specifies the security role defined in the Security Roles table in the Security section of the visual editor.</li>
<li><b>Description.</b> Specifies a description.</li>
<li><b>Run As.</b> Specifies the run-as element for the security roles.</li>
</ul>

<p>Note that when you click Remove at the top of the Servlets section, 
you remove the definitions for the servlet or JSP file from the
<tt>web.xml</tt> file, but you do not remove the servlet or JSP file itself. To delete the servlet
 or JSP file,
  right-click it in the Projects window and choose Delete.</p>
<dl>
	<dt><a name="seealso">See Also</a></dt>
	<dd><a href="../../create/servlet/about_servlet.html">About Servlets</a></dd>     
	<dd><a href="nbdocs://org.netbeans.modules.j2ee.platform/org/netbeans/modules/j2ee/platform/docs/ejb/general/about_deployment_descriptors.html">About Deployment Descriptors</a></dd>     
       <dd>	<a href="../../configure/about_webapp_configure.html">About Configuring Web Applications</a></dd>     
      <dd> <a href="../../configure/configure_webapp_dd.html">Configuring Web Application Deployment Descriptors</a></dd>     
      </dl>
     
      
<hr>
<small><a href="../../../credits.html">Legal Notices</a></small> 
<table border="0" cellpadding="20">
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
</table>
</body>
</html>


